.\" Copyright (C) 1993 David Metcalfe (david@prism.demon.co.uk)
.\"
.\" Permission is granted to make and distribute verbatim copies of this
.\" manual provided the copyright notice and this permission notice are
.\" preserved on all copies.
.\"
.\" Permission is granted to copy and distribute modified versions of this
.\" manual under the conditions for verbatim copying, provided that the
.\" entire resulting derived work is distributed under the terms of a
.\" permission notice identical to this one
.\" 
.\" Since the Linux kernel and libraries are constantly changing, this
.\" manual page may be incorrect or out-of-date.  The author(s) assume no
.\" responsibility for errors or omissions, or for damages resulting from
.\" the use of the information contained herein.  The author(s) may not
.\" have taken the same level of care in the production of this manual,
.\" which is licensed free of charge, as they might when working
.\" professionally.
.\" 
.\" Formatted or processed versions of this manual, if unaccompanied by
.\" the source, must acknowledge the copyright and authors of this work.
.\"
.\" References consulted:
.\"     Linux libc source code
.\"     Lewine's _POSIX Programmer's Guide_ (O'Reilly & Associates, 1991)
.\"     386BSD man pages
.\" Modified Sat Jul 24 18:26:16 1993 by Rik Faith (faith@cs.unc.edu)
.\" Modified Thu Apr 11 17:11:33 1996 by Andries Brouwer (aeb@cwi.nl):
.\"     Corrected type of compar routines, as suggested by
.\"     Miguel Barreiro (enano@avalon.yaix.es).  Added example.
.\" In case a Debian maintainer sees this: the Debian version is wrong.
.\" Please do not `correct' the version here.
.\"
.TH SCANDIR 3  "11 April 1996" "GNU" "Linux Programmer's Manual"
.SH NAME
scandir, alphasort \- scan a directory for matching entries
.SH SYNOPSIS
.nf
.B #include <dirent.h>
.sp
.BI "int scandir(const char *" dir ", struct dirent ***" namelist ,
.RS
.BI "int (*" select ")(const struct dirent *),"
.BI "int (*" compar ")(const struct dirent **, const struct dirent **));
.RE
.sp
.BI "int alphasort(const struct dirent **" a ", const struct dirent **" b );
.fi
.SH DESCRIPTION
The \fBscandir()\fP function scans the directory \fIdir\fP, calling
\fBselect()\fP on each directory entry.  Entries for which 
\fBselect()\fP returns non-zero are stored in strings allocated via
\fBmalloc()\fP, sorted using \fBqsort()\fP with the comparison
function \fBcompar()\fP, and collected in array \fInamelist\fP
which is allocated via \fBmalloc()\fP.
If \fBselect\fP is NULL, all entries are selected.
.PP
The \fBalphasort()\fP function can be used as the comparison function
for the \fBscandir()\fP function to sort the directory entries into
alphabetical order.  Its parameters are the two directory entries, 
\fIa\fP and \fIb\fP, to compare.
.SH "RETURN VALUE"
The \fBscandir()\fP function returns the number of directory entries
selected or \-1 if an error occurs.
.PP
The \fBalphasort()\fP function returns an integer less than, equal to, 
or greater than zero if the first argument is considered to be 
respectively less than, equal to, or greater than the second.
.SH "ERRORS"
.TP
.B ENOMEM
Insufficient memory to complete the operation.
.SH "CONFORMING TO"
BSD 4.3
.SH EXAMPLE
.nf
/* print files in current directory in reverse order */
#include <dirent.h>
main(){
    struct dirent **namelist;
    int n;

    n = scandir(".", &namelist, 0, alphasort);
    if (n < 0)
        perror("scandir");
    else
        while(n--) printf("%s\en", namelist[n]->d_name);
}
.fi
.SH "SEE ALSO"
.BR opendir (3),
.BR readdir (3),
.BR closedir (3),
.BR rewinddir (3),
.BR telldir (3),
.BR seekdir (3).
